﻿using System;
using System.Collections.Generic;
using System.IO;
using System.IO.IsolatedStorage;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Navigation;
using System.Windows.Shapes;

using Infragistics.Controls.Grids;
using Infragistics.Persistence;

namespace FilterTest
{
    public partial class Titles : Page
    {
        public string PersistName
        {
            get
            {
                return "TitlesGrid";
            }
        }

        public Titles()
        {
            InitializeComponent();
        }

        protected override void OnNavigatedTo(NavigationEventArgs e)
        {
            using (IsolatedStorageFile iso = IsolatedStorageFile.GetUserStoreForApplication())
            {
                if (iso.FileExists(PersistName))
                {
                    using (IsolatedStorageFileStream stream = new IsolatedStorageFileStream(PersistName, FileMode.Open, iso))
                    {
                        PersistenceManager.Load(TitlesGrid, stream);
                    }
                }
            }

            TitlesGrid.ItemsSource = (App.Current as App).Titles;
            TitlesGrid.Loaded += new RoutedEventHandler(TitlesGrid_Loaded);
        }

        void TitlesGrid_Loaded(object sender, RoutedEventArgs e)
        {
            if (NavigationContext.QueryString.ContainsKey("Genre"))
            {
                Column col = TitlesGrid.Columns.DataColumns["GenresBinding"];
                col.FilterColumnSettings.FilterCellValue = NavigationContext.QueryString["Genre"];
                col.FilterColumnSettings.FilteringOperand = new ContainsOperand();
            }
        }

        protected override void OnNavigatedFrom(NavigationEventArgs e)
        {
            MemoryStream ms = PersistenceManager.Save(TitlesGrid);

            using (IsolatedStorageFile iso = IsolatedStorageFile.GetUserStoreForApplication())
            {
                if (iso.FileExists(PersistName))
                    iso.DeleteFile(PersistName);

                using (IsolatedStorageFileStream fs = new IsolatedStorageFileStream(PersistName, FileMode.OpenOrCreate, iso))
                {
                    fs.Write(ms.ToArray(), 0, (int)ms.Length);
                }
            }
        }
    }
}